| OpendTect 8.0

Loading...
Searching...
No Matches
Classes | Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
EM::FaultStickSetGeometry Class Reference
EarthModel

FaultStickSet geometry. More...

`#include <emfaultstickset.h>`

Inheritance diagram for EM::FaultStickSetGeometry:
[legend]

## Classes
class | GeomGroup
class | GeomGroupUpdater

## Public Member Functions
| FaultStickSetGeometry (Surface &)
| ~FaultStickSetGeometry ()
EMObjectIterator * | createIterator (const TrcKeyZSampling *=nullptr) const override
void | fillPar (IOPar &) const override
ObjectType | FSSObjType () const
const Geometry::FaultStickSet * | geometryElement () const override
Geometry::FaultStickSet * | geometryElement () override
void | getPickedGeomIDs (TypeSet< Pos::GeomID > &) const
void | getStickNrsForGeomID (const Pos::GeomID &, TypeSet< int > &) const
void | getTrcKeyZSamplingForGeomID (const Pos::GeomID &, TrcKeyZSampling &) const
const Interval< float > & | getZRange () const
bool | insertKnot (const SectionID &, const SubID &subid, const Coord3 &pos, bool addtohistory) override
bool | insertKnot (const SubID &, const Coord3 &pos, bool addtohistory) override
bool | insertStick (const SectionID &, int sticknr, int firstcol, const Coord3 &pos, const Coord3 &editnormal, bool addtohistory) override
bool | insertStick (const SectionID &, int sticknr, int firstcol, const Coord3 &pos, const Coord3 &editnormal, const MultiID *pickedmid, const char *pickednm, bool addtohistory)
bool | insertStick (const SectionID &, int sticknr, int firstcol, const Coord3 &pos, const Coord3 &editnormal, const Pos::GeomID &pickedgeomid, bool addtohistory)
bool | insertStick (int sticknr, int firstcol, const Coord3 &pos, const Coord3 &editnormal, bool addtohistory) override
bool | insertStick (int sticknr, int firstcol, const Coord3 &pos, const Coord3 &editnormal, const MultiID *pickedmid, const char *pickednm, bool addtohistory)
bool | insertStick (int sticknr, int firstcol, const Coord3 &pos, const Coord3 &editnormal, const Pos::GeomID &pickedgeomid, bool addtohistory)
int | nrKnots (const SectionID &, int sticknr) const
int | nrKnots (int sticknr) const
int | nrSticks () const
int | nrSticks (const SectionID &) const
Pos::GeomID | pickedGeomID (const SectionID &, int sticknr) const
Pos::GeomID | pickedGeomID (int sticknr) const
const MultiID * | pickedMultiID (const SectionID &, int sticknr) const override
const MultiID * | pickedMultiID (int sticknr) const override
const char * | pickedName (const SectionID &, int sticknr) const override
const char * | pickedName (int sticknr) const override
bool | pickedOn2DLine (const SectionID &, int sticknr) const
bool | pickedOn2DLine (int sticknr) const
bool | pickedOnHorizon (const SectionID &, int sticknr) const
bool | pickedOnHorizon (int sticknr) const
bool | pickedOnPlane (const SectionID &, int sticknr) const
bool | pickedOnPlane (int sticknr) const
bool | removeKnot (const SectionID &, const SubID &subid, bool addtohistory) override
bool | removeKnot (const SubID &, bool addtohistory) override
bool | removeStick (const SectionID &, int sticknr, bool addtohistory) override
bool | removeStick (int sticknr, bool addtohistory) override
const Geometry::FaultStickSet * | sectionGeometry (const SectionID &) const override
Geometry::FaultStickSet * | sectionGeometry (const SectionID &) override
bool | usePar (const IOPar &) override
Public Member Functions inherited from EM::FaultGeometry
virtual | ~FaultGeometry ()
virtual void | copySelectedSticksTo (FaultStickSetGeometry &dest, const SectionID &sid, bool addtohistory) const
virtual void | copySelectedSticksTo (FaultStickSetGeometry &destfssg, bool addtohistory) const
virtual const Coord3 & | getEditPlaneNormal (const SectionID &, int sticknr) const
virtual const Coord3 & | getEditPlaneNormal (int sticknr) const
virtual int | nrSelectedSticks () const
virtual int | nrStickDoubles (const SectionID &, int sticknr, const FaultGeometry *ref=0) const
virtual int | nrStickDoubles (int sticknr, const FaultGeometry *ref=0) const
virtual void | removeSelectedDoubles (bool addtohistory, const FaultGeometry *ref=0)
virtual void | removeSelectedSticks (bool addtohistory)
virtual void | selectAllSticks (bool select=true)
virtual void | selectStickDoubles (bool select=true, const FaultGeometry *ref=0)
Public Member Functions inherited from EM::SurfaceGeometry
virtual | ~SurfaceGeometry ()
mDeprecatedObs SectionID | addSection (const char *nm, bool addtohistory)
mDeprecatedObs SectionID | addSection (const char *nm, const SectionID &, bool addtohistory)
virtual mDeprecatedObs SectionID | cloneSection (const SectionID &)
EMObjectIterator * | createIterator (const EM::SectionID &, const TrcKeyZSampling *t=0) const
virtual bool | enableChecks (bool yn)
virtual int | findPos (const Interval< float > &x, const Interval< float > &y, const Interval< float > &z, TypeSet< PosID > *) const
virtual mDeprecatedDef int | findPos (const SectionID &, const Interval< float > &x, const Interval< float > &y, const Interval< float > &z, TypeSet< PosID > *res) const
virtual int | findPos (const TrcKeyZSampling &, TypeSet< PosID > *) const
virtual int | getConnectedPos (const PosID &posid, TypeSet< PosID > *res) const
virtual void | getLinkedPos (const PosID &posid, TypeSet< PosID > &) const
mDeprecatedObs bool | hasSection (const SectionID &) const
virtual bool | isAtEdge (const PosID &) const
bool | isChanged (int) const
virtual bool | isChecksEnabled () const
virtual bool | isFullResolution () const
virtual bool | isLoaded () const
virtual bool | isNodeOK (const PosID &) const
virtual Executor * | loader (const SurfaceIODataSelection *=nullptr)
int | nrSections () const
virtual void | removeAll ()
virtual mDeprecatedObs bool | removeSection (const SectionID &, bool addtohistory)
void | resetChangedFlag ()
virtual Executor * | saver (const SurfaceIODataSelection *=nullptr, const MultiID *=nullptr)
mDeprecatedObs SectionID | sectionID (const char *) const
mDeprecatedObs SectionID | sectionID (int idx) const
mDeprecatedObs int | sectionIndex (const SectionID &) const
mDeprecatedObs const char * | sectionName (const SectionID &) const
mDeprecatedObs bool | setSectionName (const SectionID &, const char *, bool addtohistory)
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()

## Protected Member Functions
Geometry::FaultStickSet * | createGeometryElement () const override
GeomGroup * | getGeomGroup (const MultiID &)
GeomGroup * | getGeomGroup (const Pos::GeomID &)
bool | insertStick (int sticknr, int firstcol, const Coord3 &pos, const Coord3 &editnormal, const MultiID &pickedmid, const Pos::GeomID &pickedgeomid, bool addtohistory)
Protected Member Functions inherited from EM::FaultGeometry
| FaultGeometry (Surface &)
bool | removeSelStick (int selidx, bool addtohistory, const FaultGeometry *doublesref=0)
void | selectSticks (bool select=true, const FaultGeometry *doublesref=0)
Protected Member Functions inherited from EM::SurfaceGeometry
| SurfaceGeometry (Surface &)
mDeprecatedObs SectionID | addSectionInternal (Geometry::Element *, const char *nm, const SectionID &, bool addtohistory)
void | geomChangeCB (CallBacker *)

## Protected Attributes
ObjectSet< GeomGroup > | geomgroupset_
Interval< float > | zgate_
Protected Attributes inherited from EM::SurfaceGeometry
bool | changed_
ObjectSet< Geometry::Element > | sections_
Surface & | surface_

## Additional Inherited Members
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()

## Detailed Description

FaultStickSet geometry.

<>

## Constructor & Destructor Documentation

## ◆ FaultStickSetGeometry()

EM::FaultStickSetGeometry::FaultStickSetGeometry | ( | Surface & |  | ) |

## ◆ ~FaultStickSetGeometry()

EM::FaultStickSetGeometry::~FaultStickSetGeometry | ( |  | ) |

## Member Function Documentation

## ◆ createGeometryElement()

Geometry::FaultStickSet * EM::FaultStickSetGeometry::createGeometryElement | ( |  | ) | const
| override protected virtual

Implements EM::SurfaceGeometry.

## ◆ createIterator()

EMObjectIterator * EM::FaultStickSetGeometry::createIterator | ( | const TrcKeyZSampling * | = nullptr | ) | const
| override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ fillPar()

void EM::FaultStickSetGeometry::fillPar | ( | IOPar & |  | ) | const
| override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ FSSObjType()

ObjectType EM::FaultStickSetGeometry::FSSObjType | ( |  | ) | const

## ◆ geometryElement() [1/2]

const Geometry::FaultStickSet * EM::FaultStickSetGeometry::geometryElement | ( |  | ) | const
| override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ geometryElement() [2/2]

Geometry::FaultStickSet * EM::FaultStickSetGeometry::geometryElement | ( |  | ) |
| override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ getGeomGroup() [1/2]

GeomGroup * EM::FaultStickSetGeometry::getGeomGroup | ( | const MultiID & |  | ) |
| protected

## ◆ getGeomGroup() [2/2]

GeomGroup * EM::FaultStickSetGeometry::getGeomGroup | ( | const Pos::GeomID & |  | ) |
| protected

## ◆ getPickedGeomIDs()

void EM::FaultStickSetGeometry::getPickedGeomIDs | ( | TypeSet< Pos::GeomID > & |  | ) | const

## ◆ getStickNrsForGeomID()

void EM::FaultStickSetGeometry::getStickNrsForGeomID | ( | const Pos::GeomID & | ,
|  | TypeSet< int > & | ) const

## ◆ getTrcKeyZSamplingForGeomID()

void EM::FaultStickSetGeometry::getTrcKeyZSamplingForGeomID | ( | const Pos::GeomID & | ,
|  | TrcKeyZSampling & | ) const

## ◆ getZRange()

const Interval< float > & EM::FaultStickSetGeometry::getZRange | ( |  | ) | const
| inline

## ◆ insertKnot() [1/2]

bool EM::FaultStickSetGeometry::insertKnot | ( | const SectionID & | ,
|  | const SubID & | subid,
|  | const Coord3 & | pos,
|  | bool | addtohistory )
| inline override virtual

Reimplemented from EM::FaultGeometry.

## ◆ insertKnot() [2/2]

bool EM::FaultStickSetGeometry::insertKnot | ( | const SubID & | ,
|  | const Coord3 & | pos,
|  | bool | addtohistory )
| override virtual

Reimplemented from EM::FaultGeometry.

## ◆ insertStick() [1/7]

bool EM::FaultStickSetGeometry::insertStick | ( | const SectionID & | ,
|  | int | sticknr,
|  | int | firstcol,
|  | const Coord3 & | pos,
|  | const Coord3 & | editnormal,
|  | bool | addtohistory )
| inline override virtual

Reimplemented from EM::FaultGeometry.

## ◆ insertStick() [2/7]

bool EM::FaultStickSetGeometry::insertStick | ( | const SectionID & | ,
|  | int | sticknr,
|  | int | firstcol,
|  | const Coord3 & | pos,
|  | const Coord3 & | editnormal,
|  | const MultiID * | pickedmid,
|  | const char * | pickednm,
|  | bool | addtohistory )
| inline

## ◆ insertStick() [3/7]

bool EM::FaultStickSetGeometry::insertStick | ( | const SectionID & | ,
|  | int | sticknr,
|  | int | firstcol,
|  | const Coord3 & | pos,
|  | const Coord3 & | editnormal,
|  | const Pos::GeomID & | pickedgeomid,
|  | bool | addtohistory )
| inline

## ◆ insertStick() [4/7]

bool EM::FaultStickSetGeometry::insertStick | ( | int | sticknr,
|  | int | firstcol,
|  | const Coord3 & | pos,
|  | const Coord3 & | editnormal,
|  | bool | addtohistory )
| override virtual

Reimplemented from EM::FaultGeometry.

## ◆ insertStick() [5/7]

bool EM::FaultStickSetGeometry::insertStick | ( | int | sticknr,
|  | int | firstcol,
|  | const Coord3 & | pos,
|  | const Coord3 & | editnormal,
|  | const MultiID & | pickedmid,
|  | const Pos::GeomID & | pickedgeomid,
|  | bool | addtohistory )
| protected

## ◆ insertStick() [6/7]

bool EM::FaultStickSetGeometry::insertStick | ( | int | sticknr,
|  | int | firstcol,
|  | const Coord3 & | pos,
|  | const Coord3 & | editnormal,
|  | const MultiID * | pickedmid,
|  | const char * | pickednm,
|  | bool | addtohistory )

## ◆ insertStick() [7/7]

bool EM::FaultStickSetGeometry::insertStick | ( | int | sticknr,
|  | int | firstcol,
|  | const Coord3 & | pos,
|  | const Coord3 & | editnormal,
|  | const Pos::GeomID & | pickedgeomid,
|  | bool | addtohistory )

## ◆ nrKnots() [1/2]

int EM::FaultStickSetGeometry::nrKnots | ( | const SectionID & | ,
|  | int | sticknr ) const
| inline

## ◆ nrKnots() [2/2]

int EM::FaultStickSetGeometry::nrKnots | ( | int | sticknr | ) | const

## ◆ nrSticks() [1/2]

int EM::FaultStickSetGeometry::nrSticks | ( |  | ) | const

## ◆ nrSticks() [2/2]

int EM::FaultStickSetGeometry::nrSticks | ( | const SectionID & |  | ) | const
| inline

## ◆ pickedGeomID() [1/2]

Pos::GeomID EM::FaultStickSetGeometry::pickedGeomID | ( | const SectionID & | ,
|  | int | sticknr ) const
| inline

## ◆ pickedGeomID() [2/2]

Pos::GeomID EM::FaultStickSetGeometry::pickedGeomID | ( | int | sticknr | ) | const

## ◆ pickedMultiID() [1/2]

const MultiID * EM::FaultStickSetGeometry::pickedMultiID | ( | const SectionID & | ,
|  | int | sticknr ) const
| inline override virtual

Reimplemented from EM::FaultGeometry.

## ◆ pickedMultiID() [2/2]

const MultiID * EM::FaultStickSetGeometry::pickedMultiID | ( | int | sticknr | ) | const
| override virtual

Reimplemented from EM::FaultGeometry.

## ◆ pickedName() [1/2]

const char * EM::FaultStickSetGeometry::pickedName | ( | const SectionID & | ,
|  | int | sticknr ) const
| inline override virtual

Reimplemented from EM::FaultGeometry.

## ◆ pickedName() [2/2]

const char * EM::FaultStickSetGeometry::pickedName | ( | int | sticknr | ) | const
| override virtual

Reimplemented from EM::FaultGeometry.

## ◆ pickedOn2DLine() [1/2]

bool EM::FaultStickSetGeometry::pickedOn2DLine | ( | const SectionID & | ,
|  | int | sticknr ) const
| inline

## ◆ pickedOn2DLine() [2/2]

bool EM::FaultStickSetGeometry::pickedOn2DLine | ( | int | sticknr | ) | const

## ◆ pickedOnHorizon() [1/2]

bool EM::FaultStickSetGeometry::pickedOnHorizon | ( | const SectionID & | ,
|  | int | sticknr ) const
| inline

## ◆ pickedOnHorizon() [2/2]

bool EM::FaultStickSetGeometry::pickedOnHorizon | ( | int | sticknr | ) | const

## ◆ pickedOnPlane() [1/2]

bool EM::FaultStickSetGeometry::pickedOnPlane | ( | const SectionID & | ,
|  | int | sticknr ) const
| inline

## ◆ pickedOnPlane() [2/2]

bool EM::FaultStickSetGeometry::pickedOnPlane | ( | int | sticknr | ) | const

## ◆ removeKnot() [1/2]

bool EM::FaultStickSetGeometry::removeKnot | ( | const SectionID & | ,
|  | const SubID & | subid,
|  | bool | addtohistory )
| inline override virtual

Reimplemented from EM::FaultGeometry.

## ◆ removeKnot() [2/2]

bool EM::FaultStickSetGeometry::removeKnot | ( | const SubID & | ,
|  | bool | addtohistory )
| override virtual

Reimplemented from EM::FaultGeometry.

## ◆ removeStick() [1/2]

bool EM::FaultStickSetGeometry::removeStick | ( | const SectionID & | ,
|  | int | sticknr,
|  | bool | addtohistory )
| inline override virtual

Reimplemented from EM::FaultGeometry.

## ◆ removeStick() [2/2]

bool EM::FaultStickSetGeometry::removeStick | ( | int | sticknr,
|  | bool | addtohistory )
| override virtual

Reimplemented from EM::FaultGeometry.

## ◆ sectionGeometry() [1/2]

const Geometry::FaultStickSet * EM::FaultStickSetGeometry::sectionGeometry | ( | const SectionID & |  | ) | const
| inline override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ sectionGeometry() [2/2]

Geometry::FaultStickSet * EM::FaultStickSetGeometry::sectionGeometry | ( | const SectionID & |  | ) |
| inline override virtual

Reimplemented from EM::SurfaceGeometry.

## ◆ usePar()

bool EM::FaultStickSetGeometry::usePar | ( | const IOPar & |  | ) |
| override virtual

Reimplemented from EM::SurfaceGeometry.

## Member Data Documentation

## ◆ geomgroupset_

ObjectSet<GeomGroup> EM::FaultStickSetGeometry::geomgroupset_
| protected

## ◆ zgate_

Interval<float> EM::FaultStickSetGeometry::zgate_
| protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025